#ifndef IMCA_ASYN_UTILS_H
#define IMCA_ASYN_UTILS_H

#include <epicsEvent.h>
#include <asynDriver.h>

extern asynStatus imcaCreateConnectedIpClient(asynUser **client,
  const char *asynPortName, const char *inputEom, int inputEomLength,
  const char *outputEom, int outputEomLength);
extern asynStatus imcaCreateIpClient(asynUser **client,
  const char *asynPortName, const char *inputEom, int inputEomLength,
  const char *outputEom, int outputEomLength);
extern asynStatus imcaConnectIpClient(asynUser *client);
extern asynStatus imcaDisconnectIpClient(asynUser *client);
extern asynStatus imcaDestroyIpClient(asynUser *client);

extern asynStatus imcaCreateListeningIpServer(
  asynUser **serverConnectionHandler, const char *asynPortName,
  const char *inputEom, int inputEomLength, const char *outputEom,
  int outputEomLength);
epicsEventWaitStatus imcaWaitForIpServerConnection(asynUser **serverSession,
  asynUser *serverConnectionHandler, double timeout);
extern asynStatus imcaDestroyIpServerSession(asynUser *serverSession);
extern asynStatus imcaDestroyIpServer(asynUser *serverConnectionHandler);

extern asynStatus imcaAsynWriteString(asynUser *user, const char *value,
  double timeout);
extern asynStatus imcaAsynReadString(asynUser *user, char *value,
  size_t valueSize, double timeout);
extern asynStatus imcaAsynBufferedWrite(asynUser *user, char *buffer,
  size_t bufferSize, int *bufferLength, char whatToWrite, double timeout);
extern asynStatus imcaAsynWrite(asynUser *user, const char *whatToWrite,
  size_t whatToWriteLength, double timeout);

#endif
