#include "imca-base64.h"

/* Returns 0 on success. */
int imcaEncodeAsBase64(char *destination, int destinationSize,
    const char *data, int dataLength) {
  int i;
  int dataIndex;
  int destinationIndex;
  int buffer;
  char *base64CharacterSet;

  base64CharacterSet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    "abcdefghijklmnopqrstuvwxyz" "0123456789" "+/";

  destinationIndex = 0;
  for (dataIndex = 0; dataIndex < dataLength; dataIndex += 3) {
    buffer = (data[dataIndex] << 16) |
      (dataIndex + 1 < dataLength ? data[dataIndex + 1] << 8 : 0x0) |
      (dataIndex + 2 < dataLength ? data[dataIndex + 2] : 0x0);
    for (i = 3; i >= 0; i--)
      destination[destinationIndex++] =
        base64CharacterSet[(buffer >> (i * 6)) & 0x3f];
    if (dataIndex + 1 >= dataLength) destination[destinationIndex - 2] = '=';
    if (dataIndex + 2 >= dataLength) destination[destinationIndex - 1] = '=';
  }
  destination[destinationIndex] = '\0';

  return 0;
}
