#ifndef IMCA_CA_UTILS_H
#define IMCA_CA_UTILS_H

#include <cadef.h>
#include <db_access.h>

extern int imcaSetEpicsPvToChar(const char *pvName, dbr_char_t value);
extern int imcaGetCharFromEpicsPv(const char *pvName, dbr_char_t *value);
extern int imcaSetEpicsPvToDouble(const char *pvName, dbr_double_t value);
extern int imcaGetDoubleFromEpicsPv(const char *pvName, dbr_double_t *value);
extern int imcaSetEpicsPvToEnum(const char *pvName, dbr_enum_t value);
extern int imcaGetEnumFromEpicsPv(const char *pvName, dbr_enum_t *value);
extern int imcaSetEpicsPvToLong(const char *pvName, dbr_long_t value);
extern int imcaGetLongFromEpicsPv(const char *pvName, dbr_long_t *value);
extern int imcaSetEpicsPvToShort(const char *pvName, dbr_short_t value);
extern int imcaGetShortFromEpicsPv(const char *pvName, dbr_short_t *value);
extern int imcaSetEpicsPvToString(const char *pvName, dbr_string_t value);
extern int imcaGetStringFromEpicsPv(const char *pvName, dbr_string_t value);

extern int imcaWaitForEpicsPvToHaveValue(const char *pvName, chtype type,
  void *value);
extern int imcaWaitForEpicsPvToHaveValueWithDelta(const char *pvName,
  chtype type, void *value, double delta);
extern int imcaWaitForEpicsPvToHaveValueWithTimeout(const char *pvName,
  chtype type, void *value, double timeout);
extern int imcaWaitForEpicsPvToHaveValueWithDeltaAndTimeout(
  const char *pvName, chtype type, void *value, double delta, double timeout);

#endif
