#include <ctype.h>
#include <string.h>
#include "imca-string-utils.h"

static int basicStringEndsWith(const char *aString, const char *aSubstring,
  int shouldIgnoreCase);

void imcaStripTrailingWhitespace(char *aString) {
  int i;

  for (i = strlen(aString) - 1; i >= 0; i--) {
    if (isspace((int)aString[i])) aString[i] = '\0';
    else break;
  }
}

int imcaStringEndsWith(const char *aString, const char *aSubstring) {
  return basicStringEndsWith(aString, aSubstring, 0);
}

int imcaStringEndsWithIgnoringCase(const char *aString,
    const char *aSubstring) {
  return basicStringEndsWith(aString, aSubstring, 1);
}

static int basicStringEndsWith(const char *aString, const char *aSubstring,
    int shouldIgnoreCase) {
  int i;
  int j;

  i = strlen(aString) - 1;
  j = strlen(aSubstring) - 1;
  while (i >= 0 && j >= 0) {
    if (shouldIgnoreCase) {
      if (toupper(aString[i]) != toupper(aSubstring[j])) return 0;
    } else {
      if (aString[i] != aSubstring[j]) return 0;
    }
    i--; j--;
  }
  return j < 0;
}

int imcaStringStartsWith(const char *whole, const char *part) {
  return whole == strstr(whole, part);
}
