#!/bin/sh

APP_NAME=imcalib

THIS_SCRIPT_HOME=`dirname "$0"`
cd "$THIS_SCRIPT_HOME"
if [ $? -ne 0 ]; then
  echo "Failed to cd to \"$THIS_SCRIPT_HOME\"." 1>&2
  exit 1
fi
THIS_SCRIPT_HOME=`pwd`
if [ $? -ne 0 ]; then
  echo 'Failed to get current working directory.' 1>&2
  exit 1
fi

cd "../iocBoot/ioc$APP_NAME"
if [ $? -ne 0 ]; then
  echo "Failed to cd to \"$THIS_SCRIPT_HOME/../iocBoot/$APP_NAME\"." 1>&2
  exit 1
fi

addrAndPort1=`egrep -o -m 1 '127.0.0.1:510[0-9]+' < st.cmd`
port1=${addrAndPort1#127.0.0.1:}
let nextPort1=$port1+1
if [ $nextPort1 -gt 51035 ]; then let nextPort1=51025; fi
echo -n "Changing TCP port: $port1 -> $nextPort1..."
sed -i'.tmp' \
  -e "s!$addrAndPort1!127.0.0.1:$nextPort1!g" \
  st.cmd
if [ $? -eq 0 ]; then
  echo "OK"
  rm st.cmd.tmp
else
  echo
  echo 'Error: failed while trying to change TCP ports. Original file is'
  echo 'st.cmd.tmp. Resolve this problem before running this program again.'
fi
